<?php declare(strict_types = 1);

namespace Notes\Security;

use Psr\Http\Message\ResponseInterface;

use Notes\ObjectReflection,
    Notes\ObjectResolver;

class SecurityHandler {

    protected ResponseInterface $response;

    public function __construct(ResponseInterface $response) {
        $this->response = $response;
    }

    public function verify(string $className, string $methodName) : ? ResponseInterface {
        # Should generate an equivalent of Ulmus's object reflection here !
        if ( $this->getClassAnnotations($className, $methodName)->locked ) {
            return $this->response;
        }

        return null;
    }

    protected function getClassAnnotations(string $className, string $methodName) : \Notes\Annotation
    {
        $objectResolver = new ObjectResolver($className, true, true, false, true);

        if ( null !== ( $method = $objectResolver->getAnnotationListFromClassname( Annotation\Security::class ) ) ) {
            if ( $method[$methodName] ?? false ) {
                return $method[$methodName];
            }
        }

        if ( null !== ( $object = $objectResolver->getAnnotationFromClassname( Annotation\Security::class ) ) ) {
            return $object;
        }
    }
}
